Java解决最小路径和

Java解决最小路径和

01 题目

给定一个包含非负整数的 *m* x *n* 网格 grid ,请找出一条从左上角到右下角的路径,使得路径上的数字总和为最小。

**说明:**每次只能向下或者向右移动一步。

示例 1:

复制代码
输入:grid = [[1,3,1],[1,5,1],[4,2,1]]
输出:7
解释:因为路径 1→3→1→1→1 的总和最小。

示例 2:

复制代码
输入:grid = [[1,2,3],[4,5,6]]
输出:12

提示:

  • m == grid.length
  • n == grid[i].length
  • 1 <= m, n <= 200
  • 0 <= grid[i][j] <= 200

02 知识点

  • 二维数组
  • DP(动态规划)

03 我的题解

java 复制代码
public class digui02 {
public static void main(String[] args) {
	//测试
//		int [][] grid =new int [][] {
//		        {1,3,1},
//		        {1,5,1},
//		        {4,2,1}
//		        };
		int [][] grid =new int [][] {
	        {1,2,3},
	        {4,5,6},
	        };
		
minPathSum(grid);
}

public static int minPathSum(int[][] grid) {
	//m表示二维数组的行数,n表示二维数组的列数
	int m=grid.length;
	int n=grid[0].length;
	//用一个新的二维数组记录,走到当前格子最小的路径值
	//路径值,在原数组中每个格子都有值,经过需要累加
	int[][] nums=new int[m][n];
	//从左上角出发,再不能绕路的前提下,只能从左或从上进入一格,因为第一行和第一列都是单边,所以独立赋值
	nums[0][0]=grid[0][0];
	for (int i = 1; i < m; i++) {
		//原数组的基础上加上一格的数
		nums[i][0]+=grid[i][0]+nums[i-1][0];
	}
	for (int j = 1; j < n; j++) {
		nums[0][j]+=nums[0][j-1]+grid[0][j];
	}
	//和单边逻辑一样,但多一步比较,取较小值
	for (int i = 1; i < m; i++) {
		for (int j = 1; j < n; j++) {
			nums[i][j]=grid[i][j]+Math.min(nums[i-1][j], nums[i][j-1]);
		}
	}
	
	return nums[m-1][n-1];
}
}
相关推荐
梅雅达编程笔记4 分钟前
04-Python CSV数据保存与翻页抓取
开发语言·爬虫·python·pandas·数据采集·csv
C++ 老炮儿的技术栈10 分钟前
有符号变量与无符号变量的区别
服务器·开发语言·前端·数据结构·c++·算法·c
估值探索者17 分钟前
【Python量化策略实战 #04】Donchian 通道假突破太多?用 ATR 阈值过滤跑通真实突破信号
开发语言·python·接口·api接口·数据api接口·股票数据api接口
个 人 练 习 生19 分钟前
C++:模板初阶详解
开发语言·c++·经验分享·学习
Tisfy29 分钟前
LeetCode 0020.有效的括号:栈匹配
算法·leetcode·字符串·题解·括号匹配
知识分享小能手31 分钟前
C++ 学习教程,从入门到精通,C++类继承 — 完整知识点详解(13)
开发语言·c++·学习
弹简特35 分钟前
【Java项目-企悦抽】15-活动管理模块02-活动创建测试与活动列表实现
java·开发语言·springboot
斯内普吖36 分钟前
(开源)水果蔬菜商城实战指南 基于 Java + SSM + Vue + MySQL
java·vue.js·mysql·开源
wang_shu_mo_ran43 分钟前
Spring IoC和DI概念篇
java·后端·spring
Navigator_Z1 小时前
LeetCode //C - 1276. Number of Burgers with No Waste of Ingredients
c语言·算法·leetcode